/*
 boards/MMC3and6.h

  MacFCEU 0.5.5
*/

/* ---- externs */

extern uint8 MMC3cmd, MMC3resetmode, MMC3A000B, MMC3A001B;
extern uint8 MMC3IRQReload, MMC3IRQCount, MMC3IRQLatch, MMC3IRQa;
extern uint8 MMC3DReg[8], MMC3EXPREGS[8];

extern uint8 *MMC3WRAM;

extern void (*MMC3pwrap)(uint32 A,
	uint8 V);
extern void (*MMC3cwrap)(uint32 A,
	uint8 V);
extern void (*MMC3mwrap)(uint8 V);

/* ---- prototypes */

DECLFW(MMC3_CMDWrite); //8-B
DECLFW(MMC3_IRQWrite); //C-F

void FixMMC3PRG(int V);
void FixMMC3CHR(int V);

void GenMMC3Close(void);
void GenMMC3Power(void);
void GenMMC3Reset(void);
void GenMMC3Restore(int v);

void GenMMC3_Init(CartInfo*,
	int prg,
	int chr,
	int wram,
	int battery);

/* boards */

void TEROM_Init(CartInfo*);
void TFROM_Init(CartInfo*);
void TGROM_Init(CartInfo*);
void TKROM_Init(CartInfo*);
void TSROM_Init(CartInfo*);
void TLROM_Init(CartInfo*);
void TLSROM_Init(CartInfo*);
void TKSROM_Init(CartInfo*); //M118
void TQROM_Init(CartInfo*); //M119
void TxROM_Init(CartInfo*); //M4

// MMC6

void HKROM_Init(CartInfo*);

// Nitra

void Nitra_TDA_Init(CartInfo*); //M250

// Waixing

void Waixing_A_Init(CartInfo*); //M74
void Waixing_FFV_Init(CartInfo*); //M164
void Waixing_SH2_Init(CartInfo*); //M165
void Waixing_H_Init(CartInfo*); //M245
void Waixing_Security_Init(CartInfo*); //M249

// custom/other

void QJ_Init(CartInfo*); //M47
void RexSoftDBZ5_Init(CartInfo*); //M12
void Kasing_STD_Init(CartInfo*); //M115
void SomeriTeam_SL12_Init(CartInfo*); //M116
void G37017_Init(CartInfo*); //M208
