/*
 boards/Malee.c

 * MacFCEU 0.5.5
 *
 * Copyright notice for this file:
 *  malee.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"
#include "unlicensed.h"

static DECLFR(MALEERead6)
{
	A&= 0x7FF, A+= 0x8000;
	return Page[A>>11][A];
}

static DECLFR(MALEERead7)
{
	return GameMemBlock[A&0x7FF];
}

static DECLFW(MALEEWrite7)
{
	GameMemBlock[A&0x7FF] = V;
}

static void MALEEReset(void)
{
//	setprg2r(0x10,0x7000,0);
//	setprg2r(1,0x6000,0);
	setprg32(0x8000,0);
	setchr8(0);
	SetReadHandler(0x6000,0x6FFF,MALEERead6);
	SetReadHandler(0x7000,0x7FFF,MALEERead7);
	SetReadHandler(0x8000,0xFFFF,CartBR);
	SetWriteHandler(0x7000,0x7FFF,MALEEWrite7);
}

void BTL_MALEE_Init(CartInfo *info)
{
	info->Power = MALEEReset;
//	SetupCartPRGMapping(0x10,GameMemBlock,2048,1);
	AddExState(GameMemBlock,2048,0,"RAM"); //still "RAM" for compatibility
}
