/*
 common/args.c

 * MacFCEU 0.5.5
 *
 * Copyright notice for this file:
 *  args.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/****************************************************************/
/*			    FCE Ultra				*/
/*								*/
/*  This file contains code for parsing command-line options.   */
/*								*/
/*								*/
/****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../types.h"
#include "args.h"

static void ParseEA(int x,
	int argc,
	char *argv[],
	ARGPSTRUCT *argsps)
{
	int		y = 0;

	do
	{
		if (argsps[y].name==0)
		{
			ParseEA(x,argc,argv,(ARGPSTRUCT*)argsps[y].var);
			++y;
			continue;
		}

		if (strcmp(argv[x],argsps[y].name)==0	// A match.
				&& argsps[y].subs)
		{
			char	*myarg;
			void	*myptr;

			if (x+1>=argc)
				break;
			myarg = argv[x+1];
			myptr = argsps[y].subs;
			if (argsps[y].substype&0x2000)
				((void(*)(char*))myptr)(myarg);
			else if (argsps[y].substype&0x8000)
			{
				*(int*)myptr&=~(argsps[y].substype&~0x8000);
				*(int*)myptr|= atoi(myarg) ? argsps[y].substype&~0x8000:0;
			} else
				switch(argsps[y].substype&(~0x4000))
				{
				case 0:		// Integer
					*(int*)myptr = atoi(myarg);
					break;
				case 2:		// Double float
					*(double*)myptr = atof(myarg);
					break;
				case 1:		// String
					if (argsps[y].substype&0x4000)
					{
						if (*(char**)myptr)
							free(*(char**)myptr);
						if ((*(char**)myptr=
								(char*)malloc(strlen(myarg)+1))==0)
							break;
					}
					strcpy(*(char**)myptr,myarg);
					break;
				}
		}

		if (argsps[y].var)
			*argsps[y].var = 1;
		++y;
	} while(argsps[y].var || argsps[y].subs);
}

void ParseArguments(int argc,
	char *argv[],
	ARGPSTRUCT *argsps)
{
	int		x;

	for(x=0; x<argc; ++x)
		ParseEA(x,argc,argv,argsps);
}
