/*
 tools/paltest.c

 To compile: C -o ::bin:paltest :tools:paltest.o :obj:ftrig.c.o
*/

#include <stdio.h>
#include <stdlib.h>
#include "../enviro64.h"
#include "../utility/ftrig.h"

#define R(f,d,v)	printf(f,v)

#define W		255
#define YS		8
#define YW		(W<<YS)
#define DS		9
#define DM		(1<<DS)
#define RS		(YS+DS)
#define RM		(W<<RS)

static const int	decodeIQ[3][2] =
{
	{ 0.956*DM, 0.621*DM},
	{-0.272*DM,-0.647*DM},
	{-1.105*DM, 1.702*DM}
};

static void PrintPalette(int ntsctint,
	int ntschue)
{
	static const int	hiy[4] = {0.40*YW,0.68*YW,1.00*YW,1.01*YW};
	static const int	loy[4] = {-.12*YW,0.00*YW,0.31*YW,0.72*YW};

	unsigned	S, sat;
	ufract		H, hue;
	int		x, z, v;

	if ((sat=ntsctint)<0)
		sat = 0;
	else if (sat>9999)
		sat = 10000;
	hue = 0x40000000U+umuldiv(ntschue%360+360,(double)4294967296.0/2,360);

	for(x=0; x<4; ++x)
		for(z=0,H=hue; z<16; ++z)
		{
			int	Y, I = 0, Q = 0;

			if (z==0)
				Y = hiy[x]*DM;
			else if (z<13)
				Y = (loy[x]+hiy[x])*(DM/2),
				S = ((hiy[x]-loy[x])*sat)>>7,
				I = ifract30mul(S,fastsin(H)),
				Q = ifract30mul(S,fastcos(H)),
				H+= (ufract)(30.0*(double)4294967296.0/360);
			else if (z==13)
				Y = loy[x]*DM;
			else
				Y = 0;
			if ((v=Y+I*decodeIQ[0][0]+Q*decodeIQ[0][1]+(1<<YS-1))<0)
				v = 0;
			else if (v>RM)
				v = RM;
			R("{%u,",r,v>>RS);
			if ((v=Y+I*decodeIQ[1][0]+Q*decodeIQ[1][1]+(1<<YS-1))<0)
				v = 0;
			else if (v>RM)
				v = RM;
			R("%u,",g,v>>RS);
			if ((v=Y+I*decodeIQ[2][0]+Q*decodeIQ[2][1]+(1<<YS-1))<0)
				v = 0;
			else if (v>RM)
				v = RM;
			R("%u},\n",b,v>>RS);
		}
}

void main(int argc,
	char const*const*argv)
{
	PrintPalette(argc>1 ? atoi(argv[1]):46+10,
		argc>2 ? atoi(argv[1]):72);
}
