/*
 utility/interpreter.h
  moved here from macos/commandline.h

  Created: 2010.03.21

  MacFCEU 0.6a4

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __INTERPRETER_H

/* ---- typedefs/structures */

typedef long		evalvalue;

#define EVAL_HUGEVAL			((evalvalue)1<<(sizeof(evalvalue)<<3)-1)

/* ---- prototypes */

/* system standard */

int strcasecmp(const char *a, const char *b);
int strncasecmp(const char *a, const char *b, size_t z);

/* extended standard */

/* returns ptr to next character */
const char *readanyinteger(const char *str,
	long length,
	long int *outvalue);

int makebasestring(void *outstring,
	const char *basechars, /* can be NULL (use default chars) */
	long value,
	unsigned base,
	int minlength,
	char sign); /* pass zero to interpret unsigned */

const char *parse_number(const char *s,
	const char *e,
	double *v,
	unsigned char r); /* real (take the fractional point) */

/* added; 2009.09.03 06:37 EDT */
int parse_textloop(const char *s,
	unsigned a,
	void (*b)(unsigned a, unsigned char v));

const char *parse_wordbreak(const char *s, /* does nothing if either are NULL */
	const char *e);
const char *parse_rwordbreak(const char *s,
	const char *f);
const char *parse_skipwsp(const char *s, const char *e);

/* expects `parameter` to be from commandline_execute; returns length */
/* each division by zero will yield EVAL_HUGEVAL */
const char *parse_parameter(const char *s,
	long length,
	char *outstring, /* can be NULL; otherwise, expects at least 24 chars allocated */
	const char *(*getv)(const char *s, const char *e,
		long int *i, unsigned char *u), /* can be NULL */
	unsigned char *userdata, /* for getv */
	evalvalue (*evalindir)(evalvalue)); /* indirection; (`@`); can be NULL */

 #define __INTERPRETER_H
#endif
